"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var cli_1 = require("../../cli");
var ssh_1 = require("../../session/ssh");
exports.command = 'audio';
exports.desc = 'Quickly setup the mic & speaker on your device';
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var ssh, captureDevice, captureDevices, response_1, e_1, outputDevice, outputDevices, response_2, e_2, e_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                ssh = new ssh_1.SSHService();
                return [4, ssh.connect().catch(function (e) { return cli_1.cli.stream.error(e); })];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                _a.trys.push([2, 7, , 8]);
                return [4, ssh.listCaptureDevices()];
            case 3:
                captureDevices = _a.sent();
                if (!(captureDevices.length === 1)) return [3, 4];
                cli_1.cli.stream.success("Found only 1 capture device named: " + captureDevices[0].name);
                cli_1.cli.stream.print("We will use this device to capture sound");
                captureDevice = captureDevices[0];
                return [3, 6];
            case 4: return [4, cli_1.cli.prompt.promptList('device', "We found " + captureDevices.length + " interfaces to record sound.\n  Choose the one you want to use", captureDevices.map(function (device) { return device.name; }))];
            case 5:
                response_1 = _a.sent();
                captureDevice = captureDevices.find(function (device) { return device.name === response_1['device']; });
                _a.label = 6;
            case 6: return [3, 8];
            case 7:
                e_1 = _a.sent();
                cli_1.cli.stream.error('Error fetching audio capture device: ' + e_1.message);
                return [3, 8];
            case 8:
                if (captureDevice === undefined) {
                    cli_1.cli.stream.error("A capture device wasn't found");
                    return [2];
                }
                _a.label = 9;
            case 9:
                _a.trys.push([9, 14, , 15]);
                return [4, ssh.listOuputDevices()];
            case 10:
                outputDevices = _a.sent();
                if (!(outputDevices.length === 1)) return [3, 11];
                cli_1.cli.stream.success("Found only 1 output device named: " + outputDevices[0].name);
                cli_1.cli.stream.print("We will use this device to output sound");
                outputDevice = outputDevices[0];
                return [3, 13];
            case 11: return [4, cli_1.cli.prompt.promptList('device', "We found " + outputDevices.length + " interfaces to output sound.\n  Choose the one you want to use as your speaker", outputDevices.map(function (device) { return device.name; }))];
            case 12:
                response_2 = _a.sent();
                outputDevice = outputDevices.find(function (device) { return device.name === response_2['device']; });
                _a.label = 13;
            case 13: return [3, 15];
            case 14:
                e_2 = _a.sent();
                cli_1.cli.stream.error('Error fetching audio output device: ' + e_2.message);
                return [3, 15];
            case 15:
                if (outputDevice === undefined) {
                    cli_1.cli.stream.error("An output device wasn't found");
                    return [2];
                }
                _a.label = 16;
            case 16:
                _a.trys.push([16, 18, , 19]);
                return [4, ssh.setupAsoundConf(outputDevice, captureDevice)];
            case 17:
                _a.sent();
                cli_1.cli.stream.success('Installed /etc/asound.conf');
                return [3, 19];
            case 18:
                e_3 = _a.sent();
                cli_1.cli.stream.error('Error installing the microphone asound.conf: ' + e_3.message);
                ssh.disconnect();
                process.exit();
                return [3, 19];
            case 19: return [4, ssh.setVolumeLevel(outputDevice.card, 90)
                    .catch(function (failure) { })];
            case 20:
                _a.sent();
                cli_1.cli.stream.success('Set the output level at 80%');
                return [4, ssh.setCaptureLevel(captureDevice.card, 80)
                        .catch(function (failure) { })];
            case 21:
                _a.sent();
                cli_1.cli.stream.success('Set the capture level at 90%');
                cli_1.cli.stream.hint(chalk_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["You can test your microphone & speaker with {blue sam test microphone / speaker}"], ["You can test your microphone & speaker with {blue sam test microphone / speaker}"]))));
                ssh.disconnect();
                return [2];
        }
    });
}); };
var templateObject_1;
