import * as yargs from 'yargs';
import { SSHService } from '../../session/ssh';
import { cli } from '../../cli';

exports.command = 'demo';
exports.desc = 'Install a weather demo assistant.';

exports.handler = async (argv: yargs.Argv) => {
    const ssh = new SSHService();
    await ssh.connect().catch(e => cli.stream.error(e));
    await ssh.installSnipsPlatformDemo(output => cli.stream.printNoLN(output))
    .catch(e => cli.stream.error(e));
    ssh.disconnect();
};
