import chalk from 'chalk';
import * as yargs from 'yargs';
import { cli } from '../../cli';
import { SSHService } from '../../session/ssh';

export const command = 'speaker';
export const desc = 'Test your device speaker';

export const handler = async (argv: yargs.Argv) => {
    cli.stream.print('Testing speaker');
    const ssh = new SSHService();
    await ssh.connect().catch(e => cli.stream.error(e));

    try {
        cli.stream.loading('Playing tone on your speaker');
        await ssh.speakerTest();
    } catch (e) {
        cli.stream.stop();
        cli.stream.error('Error testing the speaker: ' + e.message);
        ssh.disconnect();
        process.exit();
    }
    cli.stream.done();
    cli.stream.hint(`Didn't hear anything ? Run :` + chalk.blue(`sam setup audio`));
    ssh.disconnect();
};
