import * as yargs from 'yargs';
import { SSHService } from '../session/ssh';
import { cli } from '../cli';

export const command = 'update';
export const desc = 'Update Snips platform on your device';
export const builder = { dir: { default: '.' } };

export const handler = async (argv: yargs.Argv) => {
    const ssh = new SSHService();
    await ssh.connect().catch(e => cli.stream.error(e));
    await ssh.updateSnips(output => cli.stream.printNoLN(output))
    .catch(e => cli.stream.error(e));
    ssh.disconnect();
};
